/* td10.y
 * Example of a bison file.
 */

%{
/* C declarations */
#include <stdio.h>
#include <stdlib.h>
#define YYSTYPE int
extern int yylex (void);
void yyerror (char const *);
%}

/* tokens */
%token NUM

%%
/* grammar rules */
input
  : /* empty */
  | input line
  ;
     
line
  : '\n'
  | exp '\n'                      { printf ("\t%d\n", $1); }
  ;
     
exp
  : NUM
  | exp '+' exp                   { $$ = $1 + $3;    }
  | exp '-' exp                   { $$ = $1 - $3;    }
  | exp '*' exp                   { $$ = $1 * $3;    }
  | exp '/' exp                   { $$ = $1 / $3;    }
  | '-' exp                       { $$ = -$2;        }
  | '(' exp ')'                   { $$ = $2;         }
  ;

%%
/* C code */
void
yyerror (char const *s)
{
  fprintf (stderr, "%s\n", s);
}

int
main (void)
{
  return yyparse ();
}
